<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>morphorobotx: Protocol Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">morphorobotx
   </div>
   <div id="projectbrief">morphorobotxsharedlibrary</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1.2 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Macros</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classProtocol-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Protocol Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="Factory_8hpp_source.html">Factory.hpp</a>&quot;</code></p>
<div class="dynheader">
Collaboration diagram for Protocol:</div>
<div class="dyncontent">
<div class="center"><img src="structProtocol__coll__graph.png" border="0" usemap="#Protocol_coll__map" alt="Collaboration graph"/></div>
<map name="Protocol_coll__map" id="Protocol_coll__map">
<area shape="rect" id="node2" href="classExperiment.html" title="{Experiment\n|# protocol\l|+ Experiment()\l+ ~Experiment()\l+ Initialize()\l+ Run()\l+ getExperimentDirAbsolute()\l+ fileManager()\l+ stateManager()\l+ hardwareManager()\l+ robot()\l+ TimeElapsedMs()\l}" alt="" coords="228,2669,423,2910"/><area shape="rect" id="node4" href="classRobot.html" title="{Robot\n||+ Robot()\l+ ~Robot()\l+ BuildFromRecipe()\l+ Goto()\l+ GetPosition()\l+ SetAxisOption()\l+ UpdateAxisState()\l+ UpdateRobotState()\l+ RegisterFields()\l+ ParseRecipeFromIni()\l+ readParameters()\l+ forceMeasurement()\l+ stateManager()\l}" alt="" coords="624,2221,784,2515"/><area shape="rect" id="node37" href="classForceMeasurement.html" title="{ForceMeasurement\n|# forceUnit\l# _fieldIdForce\l# _fieldIdVoltage\l# _fieldIdAssumedForceOffset\l|+ ForceMeasurement()\l+ ~ForceMeasurement()\l+ Init()\l+ SetSensorGain()\l+ SetSensorMaxForce()\l+ SetSensorOffsetForce()\l+ SetForceUnit()\l+ TareSensor()\l+ UpdateForce()\l# GetForceAndVoltage()\l}" alt="" coords="739,2643,936,2936"/><area shape="rect" id="node6" href="classStateManager.html" title="{StateManager\n||+ StateManager()\l+ ~StateManager()\l+ state()\l+ logger()\l+ Renew()\l+ RegisterField()\l+ RegisterFieldExc()\l+ indexOfField()\l}" alt="" coords="200,569,341,775"/><area shape="rect" id="node16" href="classDataLogger.html" title="{DataLogger\n|# filename\l# file\l# stream\l# isHeaderPrepared\l|+ DataLogger()\l+ ~DataLogger()\l+ WriteCurrentState()\l+ SetFilename()\l+ valid()\l# PrepareFileHeader()\l}" alt="" coords="461,904,611,1128"/><area shape="rect" id="node21" href="classActuatorAxis.html" title="{ActuatorAxis\n|# _localID\l# holdMs\l# _name\l# _flip\l|+ ActuatorAxis()\l+ ~ActuatorAxis()\l+ itsActuatorSystem()\l+ GotoAsync()\l+ GotoSync()\l+ GetPositionSync()\l+ SetOption()\l+ LocalID()\l+ Name()\l+ SetName()\l+ SetFlip()\l+ RegisterFields()\l+ UpdateState()\l}" alt="" coords="288,843,437,1189"/><area shape="rect" id="node27" href="classHardwareManager.html" title="{HardwareManager\n||+ HardwareManager()\l+ ~HardwareManager()\l+ AcquireHardware()\l+ GetAxisPointer()\l+ BuildRobot()\l+ stateManager()\l# AcquireSmaractDevices()\l# AcquireZaberDevices()\l# QueryComediDevices()\l}" alt="" coords="283,1852,464,2076"/><area shape="rect" id="node8" href="classMeasurementState.html" title="{MeasurementState\n|+ double_nan\l# names\l# units\l|+ operator[]()\l+ MeasurementState()\l+ ~MeasurementState()\l+ GetHeaders()\l+ DumpCurrentValues()\l+ Get()\l+ Update()\l+ Invalidate()\l+ Volatile()\l+ RegisterField()\l+ IndexOfField()\l+ Renew()\l# Update()\l}" alt="" coords="191,173,351,501"/><area shape="rect" id="node10" href="classstd_1_1vector.html" title="{std::vector\&lt; QString \&gt;\n|+ element\l|}" alt="" coords="29,5,181,91"/><area shape="rect" id="node12" href="classstd_1_1vector.html" title="{std::vector\&lt; bool \&gt;\n|+ element\l|}" alt="" coords="205,5,336,91"/><area shape="rect" id="node14" href="classstd_1_1vector.html" title="{std::vector\&lt; double \&gt;\n|+ element\l|}" alt="" coords="360,5,507,91"/><area shape="rect" id="node19" href="classstd_1_1vector.html" title="{std::vector\&lt; ActuatorAxis * \&gt;\n||}" alt="" coords="507,1256,699,1341"/><area shape="rect" id="node24" href="classActuatorSystem.html" title="{ActuatorSystem\n|+ nchannels\l# _systemID\l# _localSystemID\l|+ ActuatorSystem()\l+ ~ActuatorSystem()\l+ AddAxis()\l+ SystemID()\l+ LocalSystemID()\l+ GetAxisPointer()\l}" alt="" coords="517,1409,661,1615"/><area shape="rect" id="node33" href="classstd_1_1vector.html" title="{std::vector\&lt; ActuatorSystem * \&gt;\n||}" alt="" coords="484,1683,695,1768"/><area shape="rect" id="node29" href="classstd_1_1vector.html" title="{std::vector\&lt; Controller * \&gt;\n||}" alt="" coords="287,1683,460,1768"/><area shape="rect" id="node31" href="classController.html" title="{Controller\n||+ Controller()\l+ GetAxis()\l+ ~Controller()\l}" alt="" coords="320,1452,427,1572"/><area shape="rect" id="node39" href="classADCard.html" title="{ADCard\n|# dev\l# command\l# cmd\l# polynomial_converter\l# chanlist\l# range_info\l# maxdata\l# forceAcquisitionMode\l# buf\l|+ ADCard()\l+ ~ADCard()\l+ Init()\l+ GetVoltage()\l# PrepareCmdLib()\l# init_parsed_options()\l# cmd_src()\l# dump_cmd()\l}" alt="" coords="821,2195,979,2541"/><area shape="rect" id="node41" href="structparsed__options.html" title="{parsed_options\n|+ filename\l+ value\l+ subdevice\l+ channel\l+ aref\l+ range\l+ physical\l+ verbose\l+ n_chan\l+ n_scan\l+ freq\l|}" alt="" coords="845,1835,955,2093"/><area shape="rect" id="node44" href="classForceSensor.html" title="{ForceSensor\n|# gain\l# maxForce\l# offsetForce\l|+ ForceSensor()\l+ ~ForceSensor()\l+ SetGain()\l+ SetMaxForce()\l+ SetOffsetForce()\l+ GetOffsetForce()\l+ GetMaxForce()\l+ GetForce()\l}" alt="" coords="1003,2247,1133,2489"/><area shape="rect" id="node48" href="classFileManager.html" title="{FileManager\n|&#45; inParamsPath\l&#45; currentSessionPath\l&#45; experimentPrefix\l&#45; currentExperimentDirPath\lAbsolute\l&#45; isInitialized\l|+ FileManager()\l+ ~FileManager()\l+ setInParamsPath()\l+ getInParamsPath()\l+ setCurrentSessionPath()\l+ getCurrentSessionPath()\l+ setExperimentPrefix()\l+ getOutputDataPath()\l+ getOutParamsPath()\l+ getExperimentDirAbsolute()\l+ readParameters()\l+ prepareNewDirectory()\l+ isValid()\l# makeDir()\l# getFirstAvailableExperimentPath()\l}" alt="" coords="48,2161,277,2575"/><area shape="rect" id="node50" href="classTimer.html" title="{Timer\n|&#45; end\l&#45; start\l|+ Timer()\l+ ~Timer()\l+ Reset()\l+ TimeElapsedMs()\l&#45; timespecDiffMs()\l}" alt="" coords="464,2282,600,2454"/></map>
</div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aad2c8b699e975c093b0e18636171f863"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocol.html#aad2c8b699e975c093b0e18636171f863">Protocol</a> (<a class="el" href="classExperiment.html">Experiment</a> &amp;<a class="el" href="structProtocol.html#a67ea1f74c54d7f7445dc16ae88d28934">experiment</a>)</td></tr>
<tr class="memitem:a5d9b6d6140081f8a99d30fa56448eb1d"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocol.html#a5d9b6d6140081f8a99d30fa56448eb1d">~Protocol</a> ()</td></tr>
<tr class="memitem:a7ab9aea5ae5e4935cd9e4489cf4c7b8a"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocol.html#a7ab9aea5ae5e4935cd9e4489cf4c7b8a">run</a> ()=0</td></tr>
<tr class="memitem:a6cf60ddf14537059a5b49550b601fdba"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocol.html#a6cf60ddf14537059a5b49550b601fdba">readParameters</a> (const <a class="el" href="classParms.html">Parms</a> &amp;parms)=0</td></tr>
<tr class="memitem:a52110f851961c9a77bf93586cb7ed751"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocol.html#a52110f851961c9a77bf93586cb7ed751">writeParameters</a> (<a class="el" href="classParms.html">Parms</a> &amp;parms) const =0</td></tr>
<tr class="memitem:a67ea1f74c54d7f7445dc16ae88d28934"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classExperiment.html">Experiment</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocol.html#a67ea1f74c54d7f7445dc16ae88d28934">experiment</a> () const </td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a2e08bdeab5b8999e9cb167a413a9da3d"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classExperiment.html">Experiment</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structProtocol.html#a2e08bdeab5b8999e9cb167a413a9da3d">_experiment</a></td></tr>
</table>
<a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Abstract base class of the protocoles. </p>
</div><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aad2c8b699e975c093b0e18636171f863"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Protocol::Protocol </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classExperiment.html">Experiment</a> &amp;&#160;</td>
          <td class="paramname"><em>experiment</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Constructor, with the shared experiment </p>

</div>
</div>
<a class="anchor" id="a5d9b6d6140081f8a99d30fa56448eb1d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual Protocol::~Protocol </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Virtual destructor</p>
<p>This is mandatory but should be left empty, and will probably not be overriden. </p>

</div>
</div>
<h2>Member Function Documentation</h2>
<a class="anchor" id="a67ea1f74c54d7f7445dc16ae88d28934"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classExperiment.html">Experiment</a>&amp; Protocol::experiment </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a class="anchor" id="a6cf60ddf14537059a5b49550b601fdba"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Protocol::readParameters </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classParms.html">Parms</a> &amp;&#160;</td>
          <td class="paramname"><em>parms</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Function that will read the parameters from the given object </p>

</div>
</div>
<a class="anchor" id="a7ab9aea5ae5e4935cd9e4489cf4c7b8a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Protocol::run </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Run method</p>
<p>This is the main entry point of a protocol, in which the magic should happen. You have to override this method to be able to create a protocol. </p>

</div>
</div>
<a class="anchor" id="a52110f851961c9a77bf93586cb7ed751"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Protocol::writeParameters </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classParms.html">Parms</a> &amp;&#160;</td>
          <td class="paramname"><em>parms</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Function that will write extra parameters to the object </p>

</div>
</div>
<h2>Member Data Documentation</h2>
<a class="anchor" id="a2e08bdeab5b8999e9cb167a413a9da3d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classExperiment.html">Experiment</a>&amp; Protocol::_experiment</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="Factory_8hpp_source.html">Factory.hpp</a></li>
<li><a class="el" href="Factory_8cpp.html">Factory.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Feb 26 2013 17:54:10 for morphorobotx by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1.2
</small></address>
</body>
</html>
